// BoggleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Boggle.h"
#include "BoggleDlg.h"

CString				*Library;
int					LibLen;
static	Generation<CGrid> m_G;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoggleDlg dialog

CBoggleDlg::CBoggleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBoggleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBoggleDlg)
	m_GenCount = _T("");
	m_WordsUsed = _T("");
	m_WordsTotal = _T("");
	m_WordsRatio = _T("");
	m_BestGen = _T("");
	m_CurBest = _T("");
	m_MutationCnt = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBoggleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBoggleDlg)
	DDX_Control(pDX, IDC_GRIDSAVE, m_SaveCtrl);
	DDX_Control(pDX, IDOK, m_DoneCtrl);
	DDX_Control(pDX, IDC_MUTATIONS, m_MutationCtrl);
	DDX_Control(pDX, IDC_GENDISPLAY, m_GenGraph);
	DDX_Control(pDX, IDC_GRIDDISPLAY, m_GridDisplay);
	DDX_Control(pDX, IDC_LEXLOAD, m_LoadCtrl);
	DDX_Control(pDX, IDC_RESUME, m_ResumeCtrl);
	DDX_Control(pDX, IDC_STOP, m_StopCtrl);
	DDX_Control(pDX, IDC_GO, m_GoCtrl);
	DDX_Control(pDX, IDC_LEXLIST, m_LexList);
	DDX_Text(pDX, IDC_GENCOUNT, m_GenCount);
	DDX_Text(pDX, IDC_WORDSUSED, m_WordsUsed);
	DDX_Text(pDX, IDC_WORDSTOTAL, m_WordsTotal);
	DDX_Text(pDX, IDC_WORDSRATIO, m_WordsRatio);
	DDX_Text(pDX, IDC_BESTGEN, m_BestGen);
	DDX_Text(pDX, IDC_CURBEST, m_CurBest);
	DDX_Text(pDX, IDC_MUTATIONCNT, m_MutationCnt);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBoggleDlg, CDialog)
	//{{AFX_MSG_MAP(CBoggleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LEXLOAD, OnLexload)
	ON_BN_CLICKED(IDC_GO, OnGo)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_RESUME, OnResume)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_GRIDSAVE, OnGridsave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoggleDlg message handlers

BOOL CBoggleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here:
	m_nGeneration = 0;
	m_nMutationRate = 300;
	m_MutationCtrl.SetRange(0, 5000);
	m_MutationCtrl.SetPos(m_nMutationRate);
	m_MutationCnt.Format("%d", m_nMutationRate);
	m_LoadCtrl.SetFocus();
	UpdateData(FALSE);
	return FALSE;  // return TRUE  unless you set the focus to a control
}

void CBoggleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBoggleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBoggleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBoggleDlg::OnLexload() 
{
	CFileDialog opendlg(TRUE, "txt", "bogglelex.txt", OFN_HIDEREADONLY,
		"Text Files (*.txt)|*.txt|All Files (*.*)|*.*||");
	if (opendlg.DoModal() == IDOK)
	{
		CString csName; //holds a line of the file 

		// open the input file 
		CStdioFile theFile(opendlg.GetPathName(), CFile::modeRead);
		m_LexList.ResetContent(); //clear out the list box 

		int iLongestLine = 0; 
		
		// make sure the font in the list box device context is the same as the one in 
		// in the list box window 
		CDC* pDC = m_LexList.GetDC();
		CFont* pFont = m_LexList.GetFont(); 
		CFont* pOldFont = pDC->SelectObject(pFont); 
		
		int iPos = 0;
		while(theFile.ReadString(csName)) 
		{
			// ignore comments:
			if ((csName.Find("//") == 0) || (csName.Find("#") == 0))
				continue;
			// ignore blank lines:
			if (csName.IsEmpty())
				continue;

			// Make sure they're pretty clean:
			csName.TrimLeft();
			csName.TrimRight();
			csName.MakeUpper();
			m_LexList.AddString(csName); //save in the list box
			// keep track of horizontal extent of the longest line in pixels
			iLongestLine = max(iLongestLine, pDC->GetTextExtent(csName).cx);
			iPos++;
		}

		// Now we know the number of strings:
		::LibLen = iPos;
		if (::Library != NULL)
			delete[] ::Library;
		::Library = new CString[::LibLen];

		theFile.SeekToBegin();
		iPos = 0;
		while(theFile.ReadString(csName)) 
		{
			// ignore comments:
			if ((csName.Find("//") == 0) || (csName.Find("#") == 0))
				continue;
			// ignore blank lines:
			if (csName.IsEmpty())
				continue;

			// Make sure they're pretty clean:
			csName.TrimLeft();
			csName.TrimRight();
			csName.MakeUpper();
			::Library[iPos++] = csName;
		}
		theFile.Close();

		pDC->SelectObject(pOldFont); 
		m_LexList.ReleaseDC(pDC); 
		// Set scroll:
		m_LexList.SetHorizontalExtent(iLongestLine + 5);
	}
	// Now that there is a list to work with, enable controls:
	m_WordsTotal.Format("%d", ::LibLen);
	UpdateData(FALSE);

	m_LoadCtrl.SetButtonStyle(BS_PUSHBUTTON);
	m_ResumeCtrl.EnableWindow(FALSE);
	m_GoCtrl.EnableWindow(TRUE);
	m_GoCtrl.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_GoCtrl.SetFocus();
}

void CBoggleDlg::OnGo() 
{
	// Change the text on the Go button on the first click
	// so the user doesn't confuse it with a resume:
	m_GoCtrl.SetWindowText("Start A&gain");
	// Set the button states:
	m_LoadCtrl.EnableWindow(FALSE);
	m_DoneCtrl.EnableWindow(FALSE);
	m_SaveCtrl.EnableWindow(FALSE);
	m_GoCtrl.EnableWindow(FALSE);
	m_GoCtrl.SetButtonStyle(BS_PUSHBUTTON);
	m_StopCtrl.EnableWindow(TRUE);
	m_StopCtrl.SetFocus();
	m_StopCtrl.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_ResumeCtrl.EnableWindow(FALSE);
	m_ResumeCtrl.SetButtonStyle(BS_PUSHBUTTON);

	// Start (or restart) the Generations:
	// Reset everything to 0:
	m_GenGraph.Init(::LibLen);		// Scale the graph height
	m_GridDisplay.Init(8);

	m_nGeneration = 0;
	m_GenGraph.AddFitness(m_nGeneration, 0);
	m_GenCount.Format("%d", m_nGeneration);
	UpdateData(FALSE);

	// And god created all the animals of the earth:
	m_G.Init();
	CGrid Best;
	int curFitness = 0;
	m_nBestFitness = 0;

	// god is immortal:
	m_bRunLoop = TRUE;
	while (m_bRunLoop)
	{
		// Let there be electromagnetic radiation:
		m_G.SetMutationRate(m_nMutationRate);

		// Be fruitful and multiply:
		curFitness = m_G++;
		m_nGeneration++;

		// And god looked upon his creatures and saw they were good:
		if (curFitness > m_nBestFitness)
		{
			m_nBestFitness = curFitness;
			Best = m_G.GetBest();
			// Set the new letters:
			for (int r=0; r<8; r++)
				for (int c=0; c<8; c++)
					m_GridDisplay.SetLetter(Best.letterGrid[r+1][c+1], r, c);
			// Let all see the majesty of my creation:
			m_GridDisplay.Invalidate();
			m_BestGen.Format("%d", m_nGeneration);
			m_WordsUsed.Format("%d", curFitness);
			CString csPercent;
			csPercent.Format("%d%%", (int)((float)curFitness / ::LibLen * 100));
			m_WordsRatio = csPercent;
			SetWindowText(csPercent + "- Genetic Boggle");
			if (curFitness == ::LibLen)
			{
				// Perfection. The universe can end now.
				m_bRunLoop = FALSE;
				m_LoadCtrl.EnableWindow(TRUE);
				m_DoneCtrl.EnableWindow(TRUE);
				m_SaveCtrl.EnableWindow(TRUE);
				m_GoCtrl.EnableWindow(TRUE);
				m_GoCtrl.SetFocus();
				m_GoCtrl.SetButtonStyle(BS_DEFPUSHBUTTON);
				m_StopCtrl.EnableWindow(FALSE);
				m_StopCtrl.SetButtonStyle(BS_PUSHBUTTON);
				m_ResumeCtrl.EnableWindow(FALSE);
			}
		}
		m_GenCount.Format("%d", m_nGeneration);
		m_CurBest.Format("%d", curFitness);
		m_GenGraph.AddFitness(m_nGeneration, curFitness);
		UpdateData(FALSE);

		// Even god must obey the user:
		if(!PeekAndPump())
			return;
	}
}

void CBoggleDlg::OnStop()
{
	// Set the button states:
	m_LoadCtrl.EnableWindow(TRUE);
	m_DoneCtrl.EnableWindow(TRUE);
	m_SaveCtrl.EnableWindow(TRUE);
	m_GoCtrl.EnableWindow(TRUE);
	m_StopCtrl.EnableWindow(FALSE);
	m_StopCtrl.SetButtonStyle(BS_PUSHBUTTON);
	m_ResumeCtrl.EnableWindow(TRUE);
	m_ResumeCtrl.SetFocus();
	m_ResumeCtrl.SetButtonStyle(BS_DEFPUSHBUTTON);

	// Stop the generations:
	m_bRunLoop = FALSE;
}

void CBoggleDlg::OnResume() 
{
	// Set the buttons states:
	m_LoadCtrl.EnableWindow(FALSE);
	m_DoneCtrl.EnableWindow(FALSE);
	m_SaveCtrl.EnableWindow(FALSE);
	m_GoCtrl.EnableWindow(FALSE);
	m_StopCtrl.EnableWindow(TRUE);
	m_StopCtrl.SetFocus();
	m_StopCtrl.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_ResumeCtrl.EnableWindow(FALSE);
	m_ResumeCtrl.SetButtonStyle(BS_PUSHBUTTON);

	// Resume the Generations (don't reset the generations):
	CGrid Best;
	int curFitness = 0;

	// god is immortal:
	m_bRunLoop = TRUE;
	while (m_bRunLoop)
	{
		// Let there be electromagnetic radiation:
		m_G.SetMutationRate(m_nMutationRate);

		// Be fruitful and multiply:
		curFitness = m_G++;
		m_nGeneration++;

		// And god looked upon his creatures and saw they were good:
		if (curFitness > m_nBestFitness)
		{
			m_nBestFitness = curFitness;
			Best = m_G.GetBest();
			// Set the new letters:
			for (int r=0; r<8; r++)
				for (int c=0; c<8; c++)
					m_GridDisplay.SetLetter(Best.letterGrid[r+1][c+1], r, c);
			// Behold, I bring you good tidings of great joy:
			m_GridDisplay.Invalidate();
			m_BestGen.Format("%d", m_nGeneration);
			m_WordsUsed.Format("%d", curFitness);
			CString csPercent;
			csPercent.Format("%d%%", (int)((float)curFitness / ::LibLen * 100));
			m_WordsRatio = csPercent;
			SetWindowText(csPercent + "- Genetic Boggle");
			if (curFitness == ::LibLen)
			{
				// Perfection. The universe can end now.
				m_bRunLoop = FALSE;
				m_LoadCtrl.EnableWindow(TRUE);
				m_DoneCtrl.EnableWindow(TRUE);
				m_SaveCtrl.EnableWindow(TRUE);
				m_GoCtrl.EnableWindow(TRUE);
				m_GoCtrl.SetFocus();
				m_GoCtrl.SetButtonStyle(BS_DEFPUSHBUTTON);
				m_StopCtrl.EnableWindow(FALSE);
				m_StopCtrl.SetButtonStyle(BS_PUSHBUTTON);
				m_ResumeCtrl.EnableWindow(FALSE);
			}
		}
		m_GenCount.Format("%d", m_nGeneration);
		m_CurBest.Format("%d", curFitness);
		m_GenGraph.AddFitness(m_nGeneration, curFitness);
		UpdateData(FALSE);

		// Even god must obey the user:
		if(!PeekAndPump())
			return;
	}
}

BOOL CBoggleDlg::PeekAndPump()
{
	MSG msg;
	while(::PeekMessage(&msg, 0, 0, 0, PM_NOREMOVE))
	{
		if(!AfxGetApp()->PumpMessage())
		{
			::PostQuitMessage(0);
			return FALSE;
		}
	}
	LONG lIdle = 0;
	while(AfxGetApp()->OnIdle(lIdle++));
	return TRUE;
}

void CBoggleDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// The Mutation Rate got changed:
	if (nSBCode == TB_THUMBPOSITION)
		m_nMutationRate = nPos;
	m_MutationCnt.Format("%d", m_nMutationRate);
	UpdateData(FALSE);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CBoggleDlg::OnGridsave() 
{
	CFileDialog savedlg(FALSE, "txt", "bestgrid.txt", OFN_HIDEREADONLY,
		"Text Files (*.txt)|*.txt|All Files (*.*)|*.*||");
	if (savedlg.DoModal() == IDOK)
	{
		CStdioFile theFile(savedlg.GetPathName(),
			CFile::modeCreate | CFile::modeWrite | CFile::typeText );

		CGrid Best = m_G.GetBest();
		// Write the best letters:
		char pbuf[9];
		for (int r=0; r<8; r++)
		{
			for (int c=0; c<8; c++)
			{
				pbuf[c] = Best.letterGrid[r+1][c+1];
			}
			pbuf[8] = '\0';
			theFile.WriteString(pbuf);
			theFile.WriteString("\n");
		}
		theFile.WriteString("\n");
		theFile.Close();
	}
}
