// GridDisplay.cpp : implementation file
//

#include "stdafx.h"
#include "Boggle.h"
#include "GridDisplay.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGridDisplay

CGridDisplay::CGridDisplay()
{
}

CGridDisplay::~CGridDisplay()
{
}


BEGIN_MESSAGE_MAP(CGridDisplay, CStatic)
	//{{AFX_MSG_MAP(CGridDisplay)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGridDisplay message handlers

void CGridDisplay::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	GetClientRect(m_rect);
	dc.Rectangle(m_rect);

	// Put up the letters:
	CRect rect = m_rect;
	CString s;
	for (int r=0; r<m_nSize; r++)
		for (int c=0; c<m_nSize; c++)
		{
			s.Format("%c", gridLetter[r][c]);
			rect.left = c * m_rect.Width() / m_nSize;
			rect.right = (c + 1) * m_rect.Width() / m_nSize;
			rect.top = r * m_rect.Height() / m_nSize;
			rect.bottom = (r + 1) * m_rect.Height() / m_nSize;
			dc.DrawText(s, rect, DT_CENTER | DT_VCENTER);
		}
}

void CGridDisplay::Init(int size)
{
	m_nSize = size;
	// These lines have no effect so they got commented out:
	//m_font.DeleteObject();
	//m_font.CreatePointFont(80, "Arial");
	//SetFont(&m_font);
}

void CGridDisplay::SetLetter(char c, int row, int col)
{
	gridLetter[row][col] = c;
}
